diff -Naur --exclude=CVS --exclude=configs linux/fs/dnotify.c linux-openmosix/fs/dnotify.c
--- linux/fs/dnotify.c	2002-11-29 00:53:15.000000000 +0100
+++ linux-openmosix/fs/dnotify.c	2004-02-05 10:51:20.000000000 +0100
@@ -20,6 +20,10 @@
 #include <linux/spinlock.h>
 #include <linux/slab.h>
 
+#ifdef CONFIG_MOSIX_FS
+#include <linux/mfs.h>
+#endif /* CONFIG_MOSIX_FS */
+
 extern void send_sigio(struct fown_struct *fown, int fd, int band);
 
 int dir_notify_enable = 1;
@@ -78,6 +82,10 @@
 	inode = filp->f_dentry->d_inode;
 	if (!S_ISDIR(inode->i_mode))
 		return -ENOTDIR;
+#ifdef CONFIG_MOSIX_FS
+	if(inode->i_sb->s_magic == MFS_SUPER_MAGIC)
+		return(-EPERM);
+#endif /* CONFIG_MOSIX_FS */
 	dn = kmem_cache_alloc(dn_cache, SLAB_KERNEL);
 	if (dn == NULL)
 		return -ENOMEM;
diff -Naur --exclude=CVS --exclude=configs linux/fs/exec.c linux-openmosix/fs/exec.c
--- linux/fs/exec.c	2003-11-28 19:26:21.000000000 +0100
+++ linux-openmosix/fs/exec.c	2004-02-05 10:51:20.000000000 +0100
@@ -19,7 +19,7 @@
  * current->executable is only used by the procfs.  This allows a dispatch
  * table to check for several different types  of binary formats.  We keep
  * trying until we recognize the file or we run out of supported binary
- * formats. 
+ * formats.
  */
 
 #include <linux/config.h>
@@ -49,6 +49,13 @@
 #endif
 
 int core_uses_pid;
+#ifdef CONFIG_MOSIX
+#include <linux/hpc.h>
+#endif /* CONFIG_MOSIX */
+#ifdef CONFIG_MOSIX_DFSA
+#include <linux/dfsa_interface.h>
+#endif /* CONFIG_MOSIX_DFSA */
+
 char core_pattern[65] = "core";
 int core_setuid_ok = 0;
 /* The maximal length of core_pattern is also specified in sysctl.c */ 
@@ -75,7 +82,7 @@
 	fmt->next = formats;
 	formats = fmt;
 	write_unlock(&binfmt_lock);
-	return 0;	
+	return 0;
 }
 
 int unregister_binfmt(struct linux_binfmt * fmt)
@@ -130,6 +137,9 @@
 	if (IS_ERR(file))
 		goto out;
 
+#ifdef CONFIG_MOSIX_DFSA
+	current->mosix.dflags &= ~DSTATSDOWN;	/* NOT a DFSA system-call */
+#endif /* CONFIG_MOSIX_DFSA */
 	error = -ENOEXEC;
 	if(file->f_op && file->f_op->read) {
 		struct linux_binfmt * fmt;
@@ -185,7 +195,7 @@
  * memory to free pages in kernel mem. These are in a format ready
  * to be put directly into the top of new user memory.
  */
-int copy_strings(int argc,char ** argv, struct linux_binprm *bprm) 
+int copy_strings(int argc,char ** argv, struct linux_binprm *bprm)
 {
 	struct page *kmapped_page = NULL;
 	char *kaddr = NULL;
@@ -270,10 +280,10 @@
 {
 	int r;
 	mm_segment_t oldfs = get_fs();
-	set_fs(KERNEL_DS); 
+	set_fs(KERNEL_DS);
 	r = copy_strings(argc, argv, bprm);
 	set_fs(oldfs);
-	return r; 
+	return r;
 }
 
 /*
@@ -337,9 +347,14 @@
 	bprm->exec += stack_base;
 
 	mpnt = kmem_cache_alloc(vm_area_cachep, SLAB_KERNEL);
-	if (!mpnt) 
-		return -ENOMEM; 
-	
+	if (!mpnt)
+		return -ENOMEM;
+ 
+	if (!vm_enough_memory((STACK_TOP - (PAGE_MASK & (unsigned long) bprm->p)) >> PAGE_SHIFT)) {
+ 		kmem_cache_free(vm_area_cachep, mpnt);
+ 		return -ENOMEM;
+ 	}
+
 	down_write(&current->mm->mmap_sem);
 	{
 		mpnt->vm_mm = current->mm;
@@ -353,7 +368,7 @@
 		mpnt->vm_private_data = (void *) 0;
 		insert_vm_struct(current->mm, mpnt);
 		current->mm->total_vm = (mpnt->vm_end - mpnt->vm_start) >> PAGE_SHIFT;
-	} 
+	}
 
 	for (i = 0 ; i < MAX_ARG_PAGES ; i++) {
 		struct page *page = bprm->page[i];
@@ -364,7 +379,7 @@
 		stack_base += PAGE_SIZE;
 	}
 	up_write(&current->mm->mmap_sem);
-	
+
 	return 0;
 }
 
@@ -375,7 +390,16 @@
 	struct file *file;
 	int err = 0;
 
+#ifdef CONFIG_MOSIX_FS
+        /* if file is MFS, we need to complete in order to perform the "open"
+         * method of dentry_open (which is NULL on MFS itself) */
+        nd.express_function = EF_OPEN;
+        nd.complete_args.ints.i1 = O_RDONLY+1;
+        nd.complete_args.ints.i2 = 0;
+        err = path_lookup(name, LOOKUP_FOLLOW|LOOKUP_POSITIVE|LOOKUP_COMPLETE, &nd);
+#else
 	err = path_lookup(name, LOOKUP_FOLLOW|LOOKUP_POSITIVE, &nd);
+#endif /* CONFIG_MOSIX_FS */
 	file = ERR_PTR(err);
 	if (!err) {
 		inode = nd.dentry->d_inode;
@@ -421,7 +445,11 @@
 	return result;
 }
 
+#ifdef CONFIG_MOSIX
+int exec_mmap(void)
+#else
 static int exec_mmap(void)
+#endif /* CONFIG_MOSIX */
 {
 	struct mm_struct * mm, * old_mm;
 
@@ -449,6 +477,9 @@
 		task_unlock(current);
 		activate_mm(active_mm, mm);
 		mm_release();
+#ifdef CONFIG_MOSIX
+		mosix_exec_mmap(old_mm);
+#endif /* CONFIG_MOSIX */
 		if (old_mm) {
 			if (active_mm != old_mm) BUG();
 			mmput(old_mm);
@@ -466,7 +497,7 @@
  * disturbing other processes.  (Other processes might share the signal
  * table via the CLONE_SIGNAL option to clone().)
  */
- 
+
 static inline int make_private_signals(void)
 {
 	struct signal_struct * newsig;
@@ -484,7 +515,7 @@
 	spin_unlock_irq(&current->sigmask_lock);
 	return 0;
 }
-	
+
 /*
  * If make_private_signals() made a copy of the signal table, decrement the
  * refcount of the original table, and free it if necessary.
@@ -567,21 +598,28 @@
 	oldsig = current->sig;
 	retval = make_private_signals();
 	if (retval) goto flush_failed;
-
+	
 	/*
 	 * Make sure we have private file handles. Ask the
 	 * fork helper to do the work for us and the exit
 	 * helper to do the cleanup of the old one.
 	 */
-	 
-	files = current->files;		/* refcounted so safe to hold */
+
+	files = current->files;         /* refcounted so safe to hold */
 	retval = unshare_files();
 	if(retval)
 		goto flush_failed;
 	
-	/* 
+	/*
 	 * Release all of the old mmap stuff
 	 */
+#ifdef CONFIG_MOSIX
+	if(!(current->mosix.dflags & DDEPUTY))
+		mosix_clear_statistics();
+	if(current->mosix.dflags & DDEPUTY)
+		retval = mosix_deputy_exec_mmap(bprm->filename);
+	else
+#endif /* CONFIG_MOSIX */
 	retval = exec_mmap();
 	if (retval) goto mmap_failed;
 
@@ -593,8 +631,12 @@
 	current->sas_ss_sp = current->sas_ss_size = 0;
 
 	if (current->euid == current->uid && current->egid == current->gid) {
+#ifdef CONFIG_MOSIX
+	  	set_me_dumpable(1);
+#else
 		current->mm->dumpable = 1;
 		current->task_dumpable = 1;
+#endif /* CONFIG_MOSIX */
 	}
 	name = bprm->filename;
 	for (i=0; (ch = *(name++)) != '\0';) {
@@ -605,20 +647,27 @@
 				current->comm[i++] = ch;
 	}
 	current->comm[i] = '\0';
+#ifdef CONFIG_MOSIX
+	tell_process(current, DREQ_INFOCNG);
+#endif /* CONFIG_MOSIX */
 
 	flush_thread();
 
 	de_thread(current);
 
-	if (bprm->e_uid != current->euid || bprm->e_gid != current->egid || 
+	if (bprm->e_uid != current->euid || bprm->e_gid != current->egid ||
 	    permission(bprm->file->f_dentry->d_inode,MAY_READ))
+#ifdef CONFIG_MOSIX
+		set_me_dumpable(0);
+#else
 		current->mm->dumpable = 0;
+#endif /* CONFIG_MOSIX */
 
 	/* An exec changes our domain. We are no longer part of the thread
 	   group */
-	   
+
 	current->self_exec_id++;
-			
+
 	flush_signal_handlers(current);
 	flush_old_files(current->files);
 
@@ -646,8 +695,8 @@
 	return (p->ptrace & PT_PTRACED) && !(p->ptrace & PT_PTRACE_CAP);
 }
 
-/* 
- * Fill the binprm structure from the inode. 
+/*
+ * Fill the binprm structure from the inode.
  * Check permissions, then read the first 128 (BINPRM_BUF_SIZE) bytes
  */
 int prepare_binprm(struct linux_binprm *bprm)
@@ -701,7 +750,7 @@
 			cap_set_full(bprm->cap_inheritable);
 			cap_set_full(bprm->cap_permitted);
 		}
-		if (bprm->e_uid == 0) 
+		if (bprm->e_uid == 0)
 			cap_set_full(bprm->cap_effective);
 	}
 
@@ -724,7 +773,7 @@
  *
  */
 
-void compute_creds(struct linux_binprm *bprm) 
+void compute_creds(struct linux_binprm *bprm)
 {
 	kernel_cap_t new_permitted, working;
 	int do_unlock = 0;
@@ -736,12 +785,21 @@
 
 	if (bprm->e_uid != current->uid || bprm->e_gid != current->gid ||
 	    !cap_issubset(new_permitted, current->cap_permitted)) {
+#ifdef CONFIG_MOSIX
+                set_me_dumpable(0);
+#else
                 current->mm->dumpable = 0;
-		
+#endif /* CONFIG_MOSIX */
+
 		lock_kernel();
 		if (must_not_trace_exec(current)
+#ifdef CONFIG_MOSIX_DFSA
+		    || atomic_read(&current->fs->users) > 1
+		    || atomic_read(&current->files->users) > 1
+#else
 		    || atomic_read(&current->fs->count) > 1
 		    || atomic_read(&current->files->count) > 1
+#endif /* CONFIG_MOSIX_DFSA */
 		    || atomic_read(&current->sig->count) > 1) {
 			if(!capable(CAP_SETUID)) {
 				bprm->e_uid = current->uid;
@@ -764,9 +822,15 @@
 		current->cap_effective =
 			cap_intersect(new_permitted, bprm->cap_effective);
 	}
-	
+
         /* AUD: Audit candidate if current->cap_effective is set */
 
+#ifdef CONFIG_MOSIX
+	tell_process(current, DREQ_CAPCNG|DREQ_INFOCNG);
+#endif /* CONFIG_MOSIX */
+#ifdef CONFIG_MOSIX_DFSA
+	current->mosix.dupdates |= DFSA_UPDCRED;
+#endif /* CONFIG_MOSIX_DFSA */
         current->suid = current->euid = current->fsuid = bprm->e_uid;
         current->sgid = current->egid = current->fsgid = bprm->e_gid;
 
@@ -911,13 +975,26 @@
 		return retval;
 
 	bprm.p = PAGE_SIZE*MAX_ARG_PAGES-sizeof(void *);
-	memset(bprm.page, 0, MAX_ARG_PAGES*sizeof(bprm.page[0])); 
+	memset(bprm.page, 0, MAX_ARG_PAGES*sizeof(bprm.page[0]));
 
 	bprm.file = file;
 	bprm.filename = filename;
 	bprm.sh_bang = 0;
 	bprm.loader = 0;
 	bprm.exec = 0;
+#ifdef CONFIG_MOSIX
+	if(current->mosix.dflags & DDEPUTY)
+	{
+		mosix_deputy_count_args(argv, envp, &bprm.argc, &bprm.envc);
+		if(bprm.argc < 0 || bprm.envc < 0)
+		{
+			allow_write_access(file);
+			fput(file);
+			return(bprm.argc < 0 ? bprm.argc : bprm.envc);
+		}
+		goto counted;
+	}
+#endif /* CONFIG_MOSIX */
 	if ((bprm.argc = count(argv, bprm.p / sizeof(void *))) < 0) {
 		allow_write_access(file);
 		fput(file);
@@ -929,30 +1006,61 @@
 		fput(file);
 		return bprm.envc;
 	}
+#ifdef CONFIG_MOSIX
+	counted:
+#endif /* CONFIG_MOSIX */
 
 	retval = prepare_binprm(&bprm);
-	if (retval < 0) 
-		goto out; 
+#ifdef CONFIG_MOSIX
+	current->mosix.inexec = &bprm;
+	if((current->mosix.dflags & DDEPUTY) && retval >= 0)
+		retval = mosix_deputy_bring_strings(&bprm, (char *)regs->ebx,
+								envp, argv);
+	else
+	{
+#endif /* CONFIG_MOSIX */
+	if (retval < 0)
+		goto out;
 
 	retval = copy_strings_kernel(1, &bprm.filename, &bprm);
-	if (retval < 0) 
-		goto out; 
+	if (retval < 0)
+		goto out;
 
 	bprm.exec = bprm.p;
 	retval = copy_strings(bprm.envc, envp, &bprm);
-	if (retval < 0) 
-		goto out; 
+	if (retval < 0)
+		goto out;
 
 	retval = copy_strings(bprm.argc, argv, &bprm);
-	if (retval < 0) 
-		goto out; 
+#ifdef CONFIG_MOSIX
+	}
+#endif /* CONFIG_MOSIX */
+	if (retval < 0)
+		goto out;
 
 	retval = search_binary_handler(&bprm,regs);
+#ifdef CONFIG_MOSIX
+	current->mosix.inexec = NULL;
+	if(retval >= 0)
+	{
+		mosix_decay_exec();
+		current->mosix.sigmig = 0;
+#ifdef CONFIG_MOSIX_FS
+		current->mosix.lastexec = current->mosix.whereami ? : PE;
+#ifdef CONFIG_MOSIX_DFSA
+		current->mosix.dupdates |= DFSA_UPDSEL;
+#endif /* CONFIG_MOSIX_DFSA */
+#endif /* CONFIG_MOSIX_FS */
+	}
+#endif /* CONFIG_MOSIX */
 	if (retval >= 0)
 		/* execve success */
 		return retval;
 
 out:
+#ifdef CONFIG_MOSIX
+	current->mosix.inexec = NULL;
+#endif /* CONFIG_MOSIX */
 	/* Something went wrong, return the inode and free the argument pages*/
 	allow_write_access(bprm.file);
 	if (bprm.file)
@@ -1081,8 +1189,14 @@
 	 * If core_pattern does not include a %p (as is the default)
 	 * and core_uses_pid is set, then .%pid will be appended to
 	 * the filename */
+#ifdef CONFIG_MOSIX
+	if (!pid_in_pattern || (core_uses_pid ||
+	    (current->mm && atomic_read(&current->mm->mm_realusers) != 1)))
+#else
 	if (!pid_in_pattern
-            && (core_uses_pid || atomic_read(&current->mm->mm_users) != 1)) {
+            && (core_uses_pid || atomic_read(&current->mm->mm_users) != 1))
+#endif /* CONFIG_MOSIX */
+	{
 		rc = snprintf(out_ptr, out_end - out_ptr,
 			      ".%d", current->pid);
 		if (rc > out_end - out_ptr)
@@ -1106,13 +1220,21 @@
 	binfmt = current->binfmt;
 	if (!binfmt || !binfmt->core_dump)
 		goto fail;
+#ifdef CONFIG_MOSIX
+	if(!i_am_dumpable())
+#else
 	if (!is_dumpable(current))
+#endif /* CONFIG_MOSIX */
 	{
 		if(!core_setuid_ok || !current->task_dumpable)
 			goto fail;
 		current->fsuid = 0;
 	}
+#ifdef CONFIG_MOSIX
+	set_me_dumpable(0);
+#else  
 	current->mm->dumpable = 0;
+#endif /* CONFIG_MOSIX */
 	if (current->rlim[RLIMIT_CORE].rlim_cur < binfmt->min_coredump)
 		goto fail;
 
@@ -1134,6 +1256,10 @@
 		goto close_fail;
 	if (do_truncate(file->f_dentry, 0) != 0)
 		goto close_fail;
+#ifdef CONFIG_MOSIX
+	if(current->mosix.dflags & DDEPUTY)
+		mosix_deputy_rusage(0);
+#endif /* CONFIG_MOSIX */
 
 	retval = binfmt->core_dump(signr, regs, file);
 
@@ -1145,3 +1271,43 @@
 	unlock_kernel();
 	return retval;
 }
+
+#ifdef CONFIG_MOSIX
+/*
+ * The following routines are performed on the REMOTE side
+ * and must be updated whenever the corresponding original-code
+ * is modified:
+ */
+
+void
+execve_remote_counts(char **argv, char **envp, int *argc, int *envc)
+{
+/* the following definition must match the value
+ * of bprm.p at the beginning of do_execve():
+ * (otherwise, this constant needs to be passed as argument)
+ */
+#define BPRM_P_AS_SIZE (PAGE_SIZE*MAX_ARG_PAGES-sizeof(void *))
+	if ((*argc = count(argv, BPRM_P_AS_SIZE / sizeof(void *))) < 0)
+		return;
+	if ((*envc = count(envp, BPRM_P_AS_SIZE / sizeof(void *))) < 0)
+		return;
+}
+
+int
+execve_remote_bring_strings(struct linux_binprm *bprm, char **envp, char **argv)
+{
+	int retval;
+	char *filename = getname(bprm->filename);
+
+	if(IS_ERR(filename))
+		return((int)filename);
+	retval = copy_strings_kernel(1, &filename, bprm);
+	putname(filename);
+	if(retval < 0)
+		return(retval);
+	bprm->exec = bprm->p;
+	if((retval = copy_strings(bprm->envc, envp, bprm)) < 0)
+		return(retval);
+	return(copy_strings(bprm->argc, argv, bprm));
+}
+#endif /* CONFIG_MOSIX */
diff -Naur --exclude=CVS --exclude=configs linux/fs/fcntl.c linux-openmosix/fs/fcntl.c
--- linux/fs/fcntl.c	2003-11-28 19:26:21.000000000 +0100
+++ linux-openmosix/fs/fcntl.c	2004-02-05 10:51:20.000000000 +0100
@@ -17,6 +17,10 @@
 #include <asm/siginfo.h>
 #include <asm/uaccess.h>
 
+#ifdef CONFIG_MOSIX_DFSA
+#include <linux/dfsa_interface.h>
+#endif /* CONFIG_MOSIX_DFSA */
+
 extern int sock_fcntl (struct file *, unsigned int cmd, unsigned long arg);
 extern int fcntl_setlease(unsigned int fd, struct file *filp, long arg);
 extern int fcntl_getlease(struct file *filp);
@@ -86,6 +90,13 @@
 			files->max_fdset, start);
 	}
 	
+#ifdef CONFIG_MOSIX_DFSA
+	if((current->mosix.dflags & DREMOTE) && newfd >= files->max_fds)
+	{
+		error = -EDOITATHOME;
+		goto out;
+	}
+#endif /* CONFIG_MOSIX_DFSA */
 	error = -EMFILE;
 	if (newfd >= current->rlim[RLIMIT_NOFILE].rlim_cur)
 		goto out;
@@ -142,12 +153,24 @@
 	struct file * file, *tofree;
 	struct files_struct * files = current->files;
 
+#ifdef CONFIG_MOSIX_DFSA
+	dfsa_syscall_on_file(oldfd, 1);
+#endif /* CONFIG_MOSIX_DFSA */
 	write_lock(&files->file_lock);
 	if (!(file = fcheck(oldfd)))
 		goto out_unlock;
 	err = newfd;
 	if (newfd == oldfd)
 		goto out_unlock;
+#ifdef CONFIG_MOSIX_DFSA
+	if((current->mosix.dflags & DREMOTE) &&
+		(newfd >= files->max_fdset || newfd >= files->max_fds ||
+		(!files->fd[newfd] && FD_ISSET(newfd, files->open_fds))))
+	{
+		err = -EDOITATHOME;
+		goto out_unlock;
+	}
+#endif /* CONFIG_MOSIX_DFSA */
 	err = -EBADF;
 	if (newfd >= current->rlim[RLIMIT_NOFILE].rlim_cur)
 		goto out_unlock;
@@ -174,6 +197,11 @@
 	FD_SET(newfd, files->open_fds);
 	FD_CLR(newfd, files->close_on_exec);
 	write_unlock(&files->file_lock);
+#ifdef CONFIG_MOSIX_DFSA
+	if(tofree)
+		dfsa_close_file(newfd);
+	dfsa_open_file(newfd);
+#endif /* CONFIG_MOSIX_DFSA */
 
 	if (tofree)
 		filp_close(tofree, files);
@@ -195,6 +223,9 @@
 	int ret = -EBADF;
 	struct file * file = fget(fildes);
 
+#ifdef CONFIG_MOSIX_DFSA
+	dfsa_syscall_on_file(fildes, 1);
+#endif /* CONFIG_MOSIX_DFSA */
 	if (file)
 		ret = dupfd(file, 0);
 	return ret;
@@ -211,6 +242,16 @@
 	 * In the case of an append-only file, O_APPEND
 	 * cannot be cleared
 	 */
+#ifdef CONFIG_MOSIX_FS
+	if(!(arg & O_APPEND))
+	/* no way to guess the IS_APPEND status on MFS - need to look */
+	{
+		struct inode_operations *iops = filp->f_dentry->d_inode->i_op;
+
+		if (iops && iops->revalidate)
+			iops->revalidate(filp->f_dentry);
+	}
+#endif /* CONFIG_MOSIX_FS */
 	if (!(arg & O_APPEND) && IS_APPEND(inode))
 		return -EPERM;
 
@@ -256,6 +297,18 @@
 {
 	long err = -EINVAL;
 
+#ifdef CONFIG_MOSIX_DFSA
+	switch(cmd)
+	{
+		case F_GETFL:
+			dfsa_syscall_on_file(fd, 0);
+			break;
+		case F_DUPFD:
+		case F_SETFL:
+			dfsa_syscall_on_file(fd, 1);
+			break;
+	}
+#endif /* CONFIG_MOSIX_DFSA */
 	switch (cmd) {
 		case F_DUPFD:
 			if (arg < NR_OPEN) {
@@ -444,7 +497,11 @@
 		send_sigio_to_task(p, fown, fd, band);
 		goto out;
 	}
+#ifdef CONFIG_MOSIX
+	for_each_local_task(p) {
+#else
 	for_each_task(p) {
+#endif /* CONFIG_MOSIX */
 		int match = p->pid;
 		if (pid < 0)
 			match = -p->pgrp;
diff -Naur --exclude=CVS --exclude=configs linux/fs/file.c linux-openmosix/fs/file.c
--- linux/fs/file.c	2002-08-03 02:39:45.000000000 +0200
+++ linux-openmosix/fs/file.c	2004-02-05 10:51:20.000000000 +0100
@@ -14,6 +14,9 @@
 
 #include <asm/bitops.h>
 
+#ifdef CONFIG_MOSIX_DFSA
+#include <linux/dfsa_interface.h>
+#endif /* CONFIG_MOSIX_DFSA */
 
 /*
  * Allocate an fd array, using kmalloc or vmalloc.
@@ -99,6 +102,10 @@
 		struct file **old_fds;
 		int i;
 		
+#ifdef CONFIG_MOSIX_DFSA
+		if(files == current->files)
+			current->mosix.dupdates |= DFSA_UPDMAX;
+#endif /* CONFIG_MOSIX_DFSA */
 		old_fds = xchg(&files->fd, new_fds);
 		i = xchg(&files->max_fds, nfds);
 
@@ -166,6 +173,9 @@
 int expand_fdset(struct files_struct *files, int nr)
 {
 	fd_set *new_openset = 0, *new_execset = 0;
+#ifdef CONFIG_MOSIX_DFSA
+	fd_set *new_closed = 0, *new_opened = 0, *new_modified = 0;
+#endif /* CONFIG_MOSIX_DFSA */
 	int error, nfds = 0;
 
 	error = -EMFILE;
@@ -189,8 +199,18 @@
 	error = -ENOMEM;
 	new_openset = alloc_fdset(nfds);
 	new_execset = alloc_fdset(nfds);
+#ifdef CONFIG_MOSIX_DFSA
+	new_closed = alloc_fdset(nfds);
+	new_opened = alloc_fdset(nfds);
+	new_modified = alloc_fdset(nfds);
+#endif /* CONFIG_MOSIX_DFSA */
 	write_lock(&files->file_lock);
+#ifdef CONFIG_MOSIX_DFSA
+	if (!new_openset || !new_execset ||
+				!new_closed || !new_opened || !new_modified)
+#else
 	if (!new_openset || !new_execset)
+#endif /* CONFIG_MOSIX_DFSA */
 		goto out;
 
 	error = 0;
@@ -200,6 +220,10 @@
 		int i = files->max_fdset / (sizeof(unsigned long) * 8);
 		int count = (nfds - files->max_fdset) / 8;
 		
+#ifdef CONFIG_MOSIX_DFSA
+		if(files == current->files)
+			current->mosix.dupdates |= DFSA_UPDMAX;
+#endif /* CONFIG_MOSIX_DFSA */
 		/* 
 		 * Don't copy the entire array if the current fdset is
 		 * not yet initialised.  
@@ -209,14 +233,32 @@
 			memcpy (new_execset, files->close_on_exec, files->max_fdset/8);
 			memset (&new_openset->fds_bits[i], 0, count);
 			memset (&new_execset->fds_bits[i], 0, count);
+#ifdef CONFIG_MOSIX_DFSA
+			memcpy (new_closed, files->closed, files->max_fdset/8);
+			memcpy (new_opened, files->opened, files->max_fdset/8);
+			memcpy (new_modified, files->modified, files->max_fdset/8);
+			memset (&new_closed->fds_bits[i], 0, count);
+			memset (&new_opened->fds_bits[i], 0, count);
+			memset (&new_modified->fds_bits[i], 0, count);
+#endif /* CONFIG_MOSIX_DFSA */
 		}
 		
 		nfds = xchg(&files->max_fdset, nfds);
 		new_openset = xchg(&files->open_fds, new_openset);
 		new_execset = xchg(&files->close_on_exec, new_execset);
+#ifdef CONFIG_MOSIX_DFSA
+		new_closed = xchg(&files->closed, new_closed);
+		new_opened = xchg(&files->opened, new_opened);
+		new_modified = xchg(&files->modified, new_modified);
+#endif /* CONFIG_MOSIX_DFSA */
 		write_unlock(&files->file_lock);
 		free_fdset (new_openset, nfds);
 		free_fdset (new_execset, nfds);
+#ifdef CONFIG_MOSIX_DFSA
+		free_fdset (files->closed, nfds);
+		free_fdset (files->opened, nfds);
+		free_fdset (files->modified, nfds);
+#endif /* CONFIG_MOSIX_DFSA */
 		write_lock(&files->file_lock);
 		return 0;
 	} 
@@ -228,6 +270,14 @@
 		free_fdset(new_openset, nfds);
 	if (new_execset)
 		free_fdset(new_execset, nfds);
+#ifdef CONFIG_MOSIX_DFSA
+	if (new_closed)
+		free_fdset(new_closed, nfds);
+	if (new_opened)
+		free_fdset(new_opened, nfds);
+	if (new_modified)
+		free_fdset(new_modified, nfds);
+#endif /* CONFIG_MOSIX_DFSA */
 	write_lock(&files->file_lock);
 	return error;
 }
diff -Naur --exclude=CVS --exclude=configs linux/fs/file_table.c linux-openmosix/fs/file_table.c
--- linux/fs/file_table.c	2002-11-29 00:53:15.000000000 +0100
+++ linux-openmosix/fs/file_table.c	2004-02-05 10:51:20.000000000 +0100
@@ -58,7 +58,12 @@
 	/*
 	 * Allocate a new one if we're below the limit.
 	 */
+#ifdef CONFIG_MOSIX_FS
+	if (files_stat.nr_files < files_stat.max_files ||
+		(current->mosix.dirty_bits & MFSARG_EMPTYF_PRI)) {
+#else
 	if (files_stat.nr_files < files_stat.max_files) {
+#endif /* CONFIG_MOSIX_FS */
 		file_list_unlock();
 		f = kmem_cache_alloc(filp_cachep, SLAB_KERNEL);
 		file_list_lock();
@@ -113,6 +118,9 @@
 			file->f_op->release(inode, file);
 		fops_put(file->f_op);
 		if (file->f_mode & FMODE_WRITE)
+#ifdef CONFIG_MOSIX
+		if (!(file->f_flags & O_NOWRITEACCESS))
+#endif /* CONFIG_MOSIX */
 			put_write_access(inode);
 		file_list_lock();
 		file->f_dentry = NULL;
diff -Naur --exclude=CVS --exclude=configs linux/fs/inode.c linux-openmosix/fs/inode.c
--- linux/fs/inode.c	2003-11-28 19:26:21.000000000 +0100
+++ linux-openmosix/fs/inode.c	2004-02-05 10:51:20.000000000 +0100
@@ -18,6 +18,11 @@
 #include <linux/prefetch.h>
 #include <linux/locks.h>
 
+#ifdef CONFIG_MOSIX
+spinlock_t unique_gen_lock = SPIN_LOCK_UNLOCKED;
+unsigned long long unique_generator;
+#endif /* CONFIG_MOSIX */
+
 /*
  * New inode.c implementation.
  *
@@ -873,6 +878,9 @@
 		list_add(&inode->i_list, &inode_in_use);
 		inode->i_ino = ++last_ino;
 		inode->i_state = 0;
+#ifdef CONFIG_MOSIX
+		OPENMOSIX_VMODIFIED(inode);
+#endif /* CONFIG_MOSIX */
 		spin_unlock(&inode_lock);
 	}
 	return inode;
@@ -901,6 +909,9 @@
 			list_add(&inode->i_hash, head);
 			inode->i_ino = ino;
 			inode->i_state = I_LOCK;
+#ifdef CONFIG_MOSIX
+			OPENMOSIX_VMODIFIED(inode);
+#endif /* CONFIG_MOSIX */
 			spin_unlock(&inode_lock);
 
 			/* reiserfs specific hack right here.  We don't
@@ -924,7 +935,6 @@
 			 */
 			inode->i_state &= ~I_LOCK;
 			wake_up(&inode->i_wait);
-
 			return inode;
 		}
 
diff -Naur --exclude=CVS --exclude=configs linux/fs/ioctl.c linux-openmosix/fs/ioctl.c
--- linux/fs/ioctl.c	2003-08-25 13:44:43.000000000 +0200
+++ linux-openmosix/fs/ioctl.c	2004-02-05 10:51:20.000000000 +0100
@@ -11,6 +11,10 @@
 #include <asm/uaccess.h>
 #include <asm/ioctls.h>
 
+#ifdef CONFIG_MOSIX_DFSA
+#include <linux/dfsa_interface.h>
+#endif /* CONFIG_MOSIX_DFSA */
+
 static int file_ioctl(struct file *filp,unsigned int cmd,unsigned long arg)
 {
 	int error;
@@ -51,6 +55,9 @@
 	struct file * filp;
 	unsigned int flag;
 	int on, error = -EBADF;
+#ifdef CONFIG_MOSIX_DFSA
+	int flags_changed = 0;
+#endif /* CONFIG_MOSIX_DFSA */
 
 	filp = fget(fd);
 	if (!filp)
@@ -79,6 +86,9 @@
 				filp->f_flags |= flag;
 			else
 				filp->f_flags &= ~flag;
+#ifdef CONFIG_MOSIX_DFSA
+			flags_changed = 1;
+#endif /* CONFIG_MOSIX_DFSA */
 			break;
 
 		case FIOASYNC:
@@ -99,6 +109,9 @@
 				filp->f_flags |= FASYNC;
 			else
 				filp->f_flags &= ~FASYNC;
+#ifdef CONFIG_MOSIX_DFSA
+			flags_changed = 1;
+#endif /* CONFIG_MOSIX_DFSA */
 			break;
 
 		case FIOQSIZE:
@@ -120,6 +133,10 @@
 	}
 	unlock_kernel();
 	fput(filp);
+#ifdef CONFIG_MOSIX_DFSA
+	if(flags_changed)
+		dfsa_touch_file(fd);
+#endif /* CONFIG_MOSIX_DFSA */
 
 out:
 	return error;
diff -Naur --exclude=CVS --exclude=configs linux/fs/lockd/svc.c linux-openmosix/fs/lockd/svc.c
--- linux/fs/lockd/svc.c	2003-06-13 16:51:37.000000000 +0200
+++ linux-openmosix/fs/lockd/svc.c	2004-02-05 10:51:22.000000000 +0100
@@ -300,6 +300,9 @@
 	 * Wait for the lockd process to exit, but since we're holding
 	 * the lockd semaphore, we can't wait around forever ...
 	 */
+#ifdef CONFIG_MOSIX
+	current->mosix.ignoreoldsigs = 1;
+#endif /* CONFIG_MOSIX */
 	current->sigpending = 0;
 	interruptible_sleep_on_timeout(&lockd_exit, HZ);
 	if (nlmsvc_pid) {
diff -Naur --exclude=CVS --exclude=configs linux/fs/Makefile linux-openmosix/fs/Makefile
--- linux/fs/Makefile	2003-08-25 13:44:43.000000000 +0200
+++ linux-openmosix/fs/Makefile	2004-02-05 10:51:20.000000000 +0100
@@ -64,6 +64,9 @@
 subdir-$(CONFIG_REISERFS_FS)	+= reiserfs
 subdir-$(CONFIG_DEVPTS_FS)	+= devpts
 subdir-$(CONFIG_SUN_OPENPROMFS)	+= openpromfs
+ifdef CONFIG_MOSIX
+subdir-$(CONFIG_MOSIX_FS)       += mfs
+endif
 subdir-$(CONFIG_BEFS_FS)	+= befs
 subdir-$(CONFIG_JFS_FS)		+= jfs
 
